Project/my_app/config/routes.rb
Rails.application.routes.draw do
  resources :credit_cards
  resources :orders
  resources :categories
  resources :products
  resources :addresses
  resources :credit_cards
  devise_for :users , controllers: { registrations: 'user/registrations' }

  root 'home#home'

  get 'goodbye', to: 'application#goodbye'

  get 'extra', to: 'application#extra'

  get 'test', to: 'application#test'

  get 'log_out', to: 'extra#new'

  get 'accounts', to: 'users#index', as: 'users'

  get 'profile', to: 'users#show'

end

Project/my_app/app/models/product.rb
class Product < ApplicationRecord
    belongs_to :category
    has_one_attached :image
    has_many :orders
    #default_scope {order(:name)}
end

Project/my_app/app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_product, only: %i[ show edit update destroy ]
  before_action :check_admin, except: [:show, :index]

  include Pagy::Backend

  # GET /products or /products.json
  def index
    @products = Product.includes(:category)
  
    @products = @products.where(category_id: params[:category_id]) if params[:category_id].present?
  
    if params[:search].present? 
      search_query = "%#{params[:search]}%"
      @products = @products.where("name LIKE ? OR description LIKE ?", search_query, search_query)
    end
  
    if params[:sort_by] == 'price_asc'
      @products = @products.order(price: :asc)
    elsif params[:sort_by] == 'price_desc'
      @products = @products.order(price: :desc)
    end
  
    @pagy, @products = pagy(@products.order(:name))
  end
  

  # GET /products/1 or /products/1.json
  def show
    
  end

  # GET /products/new
  def new
    @product = Product.new
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products or /products.json
  def create
    @product = Product.new(product_params)

    respond_to do |format|
      if @product.save
        format.html { redirect_to product_url(@product), notice: "Product was successfully created." }
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /products/1 or /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to product_url(@product), notice: "Product was successfully updated." }
        format.json { render :show, status: :ok, location: @product }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1 or /products/1.json
  def destroy
    @product.destroy

    respond_to do |format|
      format.html { redirect_to products_url, notice: "Product was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product
      @product = Product.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def product_params
      params.require(:product).permit(:id, :name, :description, :sku, :stock, :price, :category_id, :image)
    end
end

Project/my_app/app/helpers/products_helper.rb
module ProductsHelper
    include Pagy::Frontend
end

Project/my_app/app/views/products/_filter_menu.html.erb
<!-- _filter_menu.html.erb -->
<%= form_tag products_path, method: :get, class: 'form-inline', id: 'products-form' do %>
  <div class="form-group mb-2">
    <%= label_tag :category_id, 'Filter by category:' %>
    <%= select_tag :category_id, options_for_select(Category.all.pluck(:name, :id), params[:category_id]), prompt: 'All'%>
    <br>
    <%= label_tag :sort_by, 'Sort by price:' %>
    <%= select_tag :sort_by, options_for_select({ 'Low to High' => 'price_asc', 'High to Low' => 'price_desc' }, params[:sort_by]), prompt: 'None'%>
    <br>
    <%= label_tag :search, 'Search:' %>
    <%= text_field_tag(:search, params[:search]) %>
    <%= submit_tag 'Filter', class: 'btn btn-primary ', style: 'font-size: 12px; padding: 7px 15px;' %>
  </div>

<% end %>

Project/my_app/app/views/products/_form.html.erb
<%= form_for(@product) do |f| %>
  <div class="form-outline mb-4">
    <%= f.text_field :name, autofocus: true, required: true, class: "form-control", style: "color: white", placeholder: "Name"%>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.text_area :description, required: true, class: "form-control", style: "color: white", placeholder: "Description"%>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.text_field :sku, required: true, class: "form-control", style: "color: white", placeholder: "SKU"%>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.number_field :stock, min: 0, required: true, class: "form-control", style: "color: white", placeholder: "Stock"%>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.number_field :price, min: 0, step: 0.01, required: true, class: "form-control", style: "color: white", placeholder: "Price"%>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.file_field :image, placeholder: "Image", style: "color: white" %>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.collection_select(:category_id, Category.all, :id, :name, {:include_blank => "Select..."} , {:required => true, :class => "form-select"}) %>
  </div>
  <br>

  <div class="actions">
    <%= f.submit button_text, class: "btn btn-primary btn-block mb-4" %>
  </div>
<% end %>

Project/my_app/app/views/products/_product.html.erb
<div id="<%= dom_id product %>">
</div>

Project/my_app/app/views/products/edit.html.erb
<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
  <div class="d-flex justify-content-center align-items-center" style="height: 90vh;">
    <div class="card" style="width: 34rem; background-color: #332d2d;">
      <div class="container-fluid d-flex justify-content-center align-items-center" style="min-height: 87vh;">
        <div class="row justify-content-center">
            <div class="col-md-12 text-black" style="width: 50vh">
                <h1 style="color: white">Editing Product</h1>

                <%= render 'form', button_text: "Update" %>
                <%= link_to 'Back', products_path, class: "btn btn-warning" %>
            </div>
        </div>
      </div>
    </div>
  </div>
</body>

Project/my_app/app/views/products/index.html.erb
<%= javascript_include_tag 'mdb' %>

<style>
  .show-link {
    color: white; /* Default color */
    transition: color 0.3s; /* Transition effect */
  }

  .show-link:hover {
    color: gray; /* Hover color */
  }
</style>

<link rel="preconnect" href="https://fonts.gstatic.com">
<link href="https://fonts.googleapis.com/css2?family=Anton&display=swap" rel="stylesheet">

<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
<div class="container mt-5">
  <h2 style="font-family: 'Anton', sans-serif;">Products</h2>
  <% if current_user.present? %>
    <% if current_user.role == "admin" %>
      <%= link_to 'New Product', new_product_path, class: "btn btn-primary mt-1 mb-3" %>
    <%end%>
  <% end %>
  <br>
  <%= render "filter_menu"%>
  <%== pagy_info(@pagy) %>
  <br>
  <br>
  <table class="table table-info table-striped table-dark">
      <thead>
        <tr>
          <th scope="col">ID</th>
          <th scope="col">Name</th>
          <th scope="col">Description</th>
          <th scope="col">Category</th>
          <th scope="col">SKU</th>
          <th scope="col">Stock</th>
          <th scope="col">Price</th>
          <th scope="col">Actions</th>
        </tr>
      </thead>
    <tbody>
      <% @products.each do |product| %>
        <tr>
          <td><%= product.id %></td>
          <td><%= product.name %></td>
          <td><%= product.description %></td>
          <td><%= product.category.name%></td>
          <td><%= product.sku %></td>
          <td><%= product.stock %></td>
          <td><%= product.price %></td>
          <% if current_user.present?%>
            <% if current_user.role == "admin" %>
              <td><%= link_to 'Show', product, class: 'show-link' %> | <%= link_to 'Edit', edit_product_path(product), class: 'show-link' %> | <%= link_to 'Destroy', product, data: { turbo_method: :delete, turbo_confirm: 'Are you sure?' }, class: 'show-link' %></td>
            <% else %>
              <td><%= link_to 'Show', product, class: 'show-link' %> | <%= link_to 'Buy Now!', orders_path(order: { user_id: current_user.id, product_id: product.id }), data: {turbo_method: :post, turbo_confirm: "Are you sure you want to buy #{product.name}?"}, class: "show-link" %>
            <% end %>
          <% else %>
            <td><%= link_to 'Show', product, class: 'show-link' %></td>
          <% end %>
        </tr>
    <% end %>
    </tbody>
  </table>
  <%== pagy_nav(@pagy) if @pagy.pages > 1 %>
  <br>
</div>
</body>

<footer class="text-center text-white  " style="margin-top: auto;">
  <div class="text-center p-2" style="background-color: #332d2d; color: #FFFFFF;">
      © 2023 Basketball Haven
  </div>
</footer>

Project/my_app/app/views/products/new.html.erb
<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
  <div class="d-flex justify-content-center align-items-center" style="height: 90vh;">
    <div class="card" style="width: 34rem; background-color: #332d2d;">
      <div class="container-fluid d-flex justify-content-center align-items-center" style="min-height: 88vh;">
        <div class="row justify-content-center">
            <div class="col-md-12 text-black" style="width: 50vh">
                <h1 style="color: white">New Product</h1>
                <br>
                <%= render 'form', button_text: "Create" %>
                <%= link_to 'Back', products_path, class: "btn btn-warning" %>
            </div>
        </div>
      </div>
    </div>
  </div>
</body>

Project/my_app/app/views/products/show.html.erb
<%= javascript_include_tag 'mdb' %>

<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
  <div class="d-flex justify-content-center align-items-center" style="height: 100vh;">
    <div class="card" style="width: 34rem; background-color: #332d2d;">
      <div class="card-body">
        <div class="d-flex justify-content-center">
          <%= image_tag @product.image %>
        </div>
        <h5 class="card-title" style="color: white;">Product name: <%= @product.name %></h5>
        <br>
        <p class="card-text" style="color: white;">Description: <%= @product.description %></p>
        <p class="card-text" style="color: white;">Product sku: <%= @product.sku %></p>
        <p class="card-text" style="color: white;">Stock left: <%= @product.stock %></p>
        <p class="card-text" style="color: white;">Price: <%= @product.price %> $</p>
        <div class="d-flex justify-content-center">
          <% if current_user.present? %>
            <%= button_to 'Buy Now!', orders_path(order: { user_id: current_user.id, product_id: @product.id }), data: {turbo_method: :post, turbo_confirm: "Are you sure you want to buy #{@product.name}?"}, class: "btn btn-primary", style: "margin-right: 20px;" %>
          <% else %>
            <p class="mb-0", style="color: #b3b3b3; margin-right: 20px;">You need to be logged in to order!</p>
          <% end %>
          <button class="btn btn-warning" onclick="goBack()">Back</button>
        </div>

      </div>
    </div>
  </div>

<script>
  function goBack() {
    history.back();
  }
</script>


</body>